// PICSLabelOptions.java
// by Yang-hua Chu
// last update: 10/11/96

package w3c.pics.referee;

import java.io.* ;
import java.net.*;


public class PICSLabelOptions {
  String byOption = null;
  boolean genericOption = false;
  URL forOption;
  String untilOption = null;
  String RSAOption;
  String atOption;
  String md5Option;
  String commentOption;
  URL fullOption;
  String extensionOption;


  public boolean parse(SExp exp)
       throws PICSParseException
  {
    boolean success = false;
    
    while (true) {
      if (! exp.expect(exp.SEXP_IDENT)) {
	exp.pushBack();
	break;
      }
      String opt = exp.current().getIdent();

      if (opt.equals("by")) {
	if (exp.expect(exp.SEXP_STRING)) {
	  byOption = exp.current().getString();
	  success = true;
	  continue;
	} else 
	  throw new PICSParseException(exp.errorMsg("quotename for by"));
      }
      exp.pushBack();
      break;
    }
    return success;
  }
  
  public String toString()
  {
    String s = "";
    
    if (this.byOption != null)
      s += "by " + "\"" + byOption + "\"" + "\n";
    
    return (s);
  }
}
