// PICSSingleLabel.java
// by Yang-hua Chu
// last update: 10/11/96

package w3c.pics.referee;

import java.io.* ;
import java.net.*;

public class PICSSingleLabel {
  PICSLabelOptions options = new PICSLabelOptions();
  PICSLabelRatings ratings = new PICSLabelRatings();
  // String error;

  public boolean parse(SExp exp) 
       throws PICSParseException
  {
    
    // label :: label-error => label-error:: 'error' ...
    // if (exp.expect(exp.SEXP_STRING, "error")) {
    //  continue;
    // }

    // single-label :: [option*] ratingword '(' rating+ ')'
    options.parse(exp);
    
    // single-label :: option* [ratingword] '(' rating+ ')'
    if (! (exp.expect(exp.SEXP_IDENT, "r") ||
	   exp.expect(exp.SEXP_IDENT, "ratings")))
      return false;
    
    if (! exp.expect(exp.SEXP_SEXP))
      throw new PICSParseException(exp.errorMsg("S-expression for ratings"));
    
    if (! ratings.parse(exp.current()))
      throw new PICSParseException(exp.current().errorMsg("one or more ratings"));

    return true;
  }

  public String toString()
  {
    String s = "\n" + options.toString();
    s += ratings.toString();
    return s;
  }


}
