// Profiles.java
// by Yang-hua Chu
// last update: 10/11/96

package w3c.pics.referee;

import java.io.* ;
import java.net.*;
import java.util.*;
import w3c.pics.util.*;
import w3c.pics.label.*;

public class LabelParser
{
  private PICSLabelList list[] = {};


  public int addLabel(PICSLabelList inList)
  {
    PICSLabelList nlist[] = new PICSLabelList[size() + 1] ;
    System.arraycopy (list, 0, nlist, 0, size()) ;
    list = nlist;
    list[size()-1] = inList;
    return (size()-1);
  }


  public int size()
  {
    return list.length;
  }


  public SExp search(targetURL)
  {
    SExp result = new SExp(SEXP.SEXP_SEXP);
    
    SExp versionSExp = new SExp(SExp.SEXP_SEXP);
    versionSExp.addIdent("version");
    versionSExp.addString(this.version);

    SExp originalSExp = new SExp(SExp.SEXP_SEXP);
    originalSExp.addIdent("original");
    originalSExp.addSExp(new SExp(this.toString()));
    
    for (int i=0; i<this.size(); i++) {
      PICSLabel label = getPICSLabel(i);

      SExp serviceSExp = new SExp(SExp.SEXP_SEXP);
      serviceSExp.addIdent("service");
      serviceSExp.addString(label.serviceID.toString());
      
      for (int j=0; j<label.size(); j++) {
	PICSSingleLabel single_label = label.getSingleLabel(j); 
	SExp content = new SExp(SExp.SEXP_SEXP);
	content.addSExp(versionSExp);
	content.addSExp(serviceSExp);
	content.addSExp(originalSExp);
	
	SExp opt = new SExp("("+single_label.options.toString()+")");
	for (int k=1; k<=opt.size(); k=k+2) {
	  SExp nopt = new SExp(SExp.SEXP_SEXP);
	  nopt.addSExp(opt.getSExp(k));
	  nopt.addSExp(opt.getSExp(k+1));
	  content.addSExp(nopt);
	}
	content.addSExp(new SExp("(" + single_label.ratings.toString() + ")"));
	Statement nstmt = new Statement(speaker, new SExp(content.toString()));
	stmt_list.addStatement(nstmt);
      }
    }
    System.out.println("check: " + stmt_list.toString() + stmt_list.size());
    return stmt_list;
  }

}





