// ReturnedValues.java
// by Yang-hua Chu
// last update: 10/11/96

package w3c.pics.referee;

import java.io.* ;
import java.net.*;
import java.util.*;

public class StatementList {
  private Statement list[] = {};
  private int size = 0;
  
  // adds stmt into 'this', returns the pointer to the statement in 'this'
  public int addStatement(Statement stmt)
  {
    for (int i=1; i<=size(); i++) {
      if (stmt.match(getStatement(i)))
	return i;
    }
    if (size >= list.length) {
      Statement newList[] = new Statement[list.length*2 + 1];
      System.arraycopy (list, 0, newList, 0, list.length) ;
      list = newList;
    }
    list[size] = stmt;
    size++;
    return size;
  }
  
  public void merge(StatementList stmtList)
  {
    for (int i=1; i <= stmtList.size(); i++) 
      this.addStatement(stmtList.getStatement(i));
  }

  public Statement getStatement(int index)
  {
    return this.list[index-1];
  }

  public int size()
  {
    return this.size;
  }

  public String toString()
  {
    String s = "( ";
    for (int i=1; i <= this.size(); i++)
      s += this.getStatement(i).toString() + "\n";
    s += " )";
    return (new SExp(s)).toString();
  }
}
